#!/usr/bin/env/ ruby
# -*- coding: utf-8 -*-

class SidfmdPvtFilter < ActiveRecord::Base
  belongs_to :user

  #更新・登録で使うデータ
  def data
    {
      :type => 'private',
      :id => self.id,
      :name => self.name,
      :user_id => self.user_id,
      :keyword => self.keyword,
      :filters => JSON.parse(self.filters)
    }
  end

  def self.get_filters(keyword, user_id = nil)
    ret = []
    rows = self.where(:keyword => keyword).order('LOWER(name COLLATE "C")').order(:id)
    if user_id then
      rows = rows.where(:user_id => user_id)
    end
    rows.each do |row|
      begin
        ret << row.data
      rescue JSON::ParserError => e
        log_exception(e)
      end
    end
    ret
  end
end

