var product_box = (function(){
  "use strict";
  var product_box = {};
  var _this = product_box;

  _this.show = function(){
    var product_id = parseInt($('#id').val());
    _this.product_id = product_id;
    _this.now = new Date();
    _this.dt2 = new Date();
    _this.dt1 = new Date();
    _this.dt1.setYear(_this.dt1.getFullYear() - 1);
    var local_product = $('#local_product').val();
    if( local_product) {
        local_product = JSON.parse(local_product);
        _this.product = local_product;
        _this.eols = JSON.parse($('#local_product_eols').val());
        _this.vulns = JSON.parse($('#local_product_vulns').val());
        _this.affects_hosts = JSON.parse($('#local_product_affect_hosts').val());
        _this.areas = JSON.parse($('#areas').val());
        _this.risks = JSON.parse($('#risks').val());
        _this.render_page();
        _this.bind_event();
       if(_this.product.support_date != null){
           _this.mindt = new Date(_this.product.support_date);
       }else if(_this.product.create_datetime != null){
           _this.mindt = new Date(_this.product.create_datetime);
       }else{
           _this.mindt = new Date(1998,10,1);
       }
       _this.update_page();
       _this.make_data();
       _this.make_crossfilter();
       _this.render_charts();
       _this.render_vulns();
      _this.update_page();
      if(vulns.length > 0){
        _this.make_vulns(vulns);
        _this.vulns = _this.vulns.concat(vulns);
        _this.cf_vulns.add(vulns);
        _this.render_charts();
        _this.render_vulns();
      }
       $(".j_load_indicator").removeClass("_loading").addClass("_complete");
       $(".j_lazy_load_switch").prop("disabled", true);
    }else{
        var product_req = $.post($('#sidfm_internal_api_info_product_path').val(), {id: _this.product_id}, function(res){_this.product = res.product});
        var eols_req = $.post($('#sidfm_internal_api_info_product_eols_path').val(), {product_id: _this.product_id}, function(res){_this.eols = res.product_eols;});
        var areas_req = $.post($('#sidfm_internal_api_info_areas_path').val(), function(res){_this.areas = res.areas;});
        var risks_req = $.post($('#sidfm_internal_api_info_risks_path').val(), function(res){_this.risks = res.risks;});
        var vulns_req_params = {begin_datetime:_this.dt1.toISOString(), end_datetime:_this.dt2.toISOString(), product_id:product_id};
        var vulns_req = $.post($('#sidfm_internal_api_info_product_vulns_path').val(), vulns_req_params, function(res){_this.vulns = res.vulns});
        var affects_hosts_req = $.get($('#sidfm_informations_api_prd2hosts_path').val().replace('___ID___', '' + product_id), function(res){_this.affects_hosts = res;});
        $.when(product_req, areas_req, risks_req, eols_req, affects_hosts_req).done(function(){
            _this.eols.forEach(function(eol){
                var eol_date = new Date(eol.date)
                if(_this.now > eol_date){
                    eol.is_support_end = true;
                }
            });
            _this.render_page();
            _this.bind_event();
            if(_this.product.support_date != null){
                _this.mindt = new Date(_this.product.support_date);
            }else if(_this.product.create_datetime != null){
                _this.mindt = new Date(_this.product.create_datetime);
            }else{
                _this.mindt = new Date(1998,10,1);
            }
    		});

        $.when(product_req, areas_req, risks_req, eols_req, vulns_req, affects_hosts_req).done(function(){
            _this.update_page();
            _this.make_data();
            _this.make_crossfilter();
            _this.render_charts();
            _this.render_vulns();
           if(_this.mindt != null && _this.mindt >= _this.dt1){
               $(".j_load_indicator").removeClass("_loading").addClass("_complete");
               $(".j_lazy_load_switch").prop("disabled", true);
           }else{
               _this.lazy_load_id = setTimeout(_this.lazy_load, 3000);
           }
        });
    }
 };

  _this.lazy_load = function(){
    var dt2 = _this.dt1;
    var dt1 = new Date(_this.dt1.getTime());
    dt1.setYear(dt1.getFullYear() - 1);
    if(_this.mindt > dt1){
      dt1 = new Date(_this.mindt.getTime());
    }
    var vulns_req_params = {begin_datetime:dt1.toISOString(), end_datetime:dt2.toISOString(), product_id:_this.product.id};
    var vulns = [];
    var vulns_req = $.post($('#sidfm_internal_api_info_product_vulns_path').val(), vulns_req_params, function(res){vulns = res.vulns});
    $.when(vulns_req).done(function(){
      _this.dt1 = dt1;
      _this.update_page();
      if(vulns.length > 0){
        vulns = vulns.filter(function(v){return (v.affect_products.length > 0)});
        _this.make_vulns(vulns);
        _this.vulns = _this.vulns.concat(vulns);
        _this.cf_vulns.add(vulns);
        _this.render_charts();
        _this.render_vulns();
      }
      if(dt1 > _this.mindt){
        _this.lazy_load_id = setTimeout(_this.lazy_load, 3000);
      }else if(_this.mindt >= dt1){
        var j_switch = $(".j_lazy_load_switch");
        var complete_text = j_switch.get(0).dataset.completeText;
        j_switch.prop("disabled", true).text(complete_text);
        $(".j_load_indicator").removeClass("_loading").addClass("_complete");
      }
    });
  };

  _this.make_data = function(){
    _this.product.versions.forEach(function(ver){
      ver.release_date = typeof ver.release_date === "string" ? ver.release_date.replace(/-/g, "/") : "";
      ver.eol_date = typeof ver.eol_date === "string" ? ver.eol_date.replace(/-/g, "/") : "";
      ver.support_date = typeof ver.support_date === "string" ? ver.support_date.replace(/-/g, "/") : "";
    });

    this.vulns = _this.vulns.filter(function(v){return (v.affect_products.length > 0)});
    _this.make_vulns(_this.vulns);

    _this.cvss3_color_map = {};
    ["av","ac","pr","ui","s","c","i","a"].forEach(function(key){
      var metric = SidCvss3Map[key];
      Object.keys(metric.value_name).forEach(function(v){
        _this.cvss3_color_map[key.toUpperCase() + ":" + metric.value_name[v]] = d3.color(metric.colors[v]).hex();
      });
    });
    _this.cvss2_color_map = {};
    ["AV","AC","Au","C","I","A"].forEach(function(key){
      var metric = SidCvss2Map[key.toLowerCase()];
      Object.keys(metric.value_name).forEach(function(v){
        _this.cvss2_color_map[key + ":" + metric.value_name[v]] = d3.color(metric.colors[v]).hex();
      });
    });
    _this.sid_color_map = {}
    _this.risks.forEach(function(risk){
      var c = d3.hsl(SidColors.risk[risk.id]);
      _this.sid_color_map[risk.name] = c;
    });
    _this.areas.forEach(function(area){
      var c = d3.hsl(SidColors.risk[area.id]);
      _this.sid_color_map[area.name] = c.darker(0.5);
    });
  };

  _this.make_vulns = function(vulns){
    var cvss2_x = SidCvss2Map.parse_vector_string({base_score:-1, base_score_i:-1})
    var cvss3_x = SidCvss3Map.parse_vector_string({base_score:-1, base_score_i:-1})
    vulns.forEach(function(vuln){
      vuln.cves.forEach(function(cve){
        if(cve.cvss2 == null){
          cve.cvss2 = cvss2_x;
        }
        if(cve.cvss3 == null){
          cve.cvss3 = cvss3_x;
        }
        //最大値・ソート用 //CVSS3優先
        if(cve.cvss3.base_score >= 0){
          cve.cvss3.base_score_i = Math.floor(cve.cvss3.base_score);
          cve.cve_cvss = SidCvss3Map.parse_vector_string(cve.cvss3);
          cve.cve_cvss.ver = 3;
        }
         cve.cvss2.base_score_i = Math.floor(cve.cvss2.base_score);
        if(cve.cvss2.base_score >= 0){
          cve.cve_cvss = SidCvss2Map.parse_vector_string(cve.cvss2);
          cve.cve_cvss.ver = 2;
        }
        if(cve.cvss3.base_score === -1 && cve.cvss2.base_score === -1){
          cve.cve_cvss = cvss3_x;
        }
      });
      var max_cvss_cve = _.max(vuln.cves, function(cve){return cve.cve_cvss.base_score});
      if(max_cvss_cve !== -Infinity && max_cvss_cve.cve_cvss.base_score >= 0){
        if(max_cvss_cve.cvss3.base_score >= 0){
          vuln.max_cvss = max_cvss_cve.cvss3;
        }else{
          vuln.max_cvss = max_cvss_cve.cvss2;
        }
      }else{
        vuln.max_cvss = cvss3_x;
      }
      var max_cvss2_cve = _.max(vuln.cves, function(cve){return cve.cvss2.base_score;})
      if(max_cvss2_cve === -Infinity){
        vuln.max_cvss2 = cvss2_x;
      }else{
        vuln.max_cvss2 = max_cvss2_cve.cvss2;
      }
      var max_cvss3_cve = _.max(vuln.cves, function(cve){return cve.cvss3.base_score;})
      if(max_cvss3_cve === -Infinity){
        vuln.max_cvss3 = cvss3_x;
      }else{
        vuln.max_cvss3 = max_cvss3_cve.cvss3;
      }
      vuln.area = _.find(_this.areas, function(area){return area.id === vuln.area_id});
      vuln.risk = _.find(_this.risks, function(risk){return risk.id === vuln.risk_id});
      //if( vuln.affect_products[0] ){
          vuln.affect_create_datetime = new Date(vuln.affect_products[0].create_datetime);
          vuln.affect_create_date_str = vuln.affect_products[0].create_datetime.substr(0,10).replace(/-/g, "/");
      /*}else{
          vuln.affect_create_datetime = new Date(vuln.create_datetime);
          vuln.affect_create_date_str = vuln.create_datetime.substr(0,10).replace(/-/g, "/");
      }*/
    });
  };

  _this.render_page = function(){
    var tmpl = $("#template").html();
    var compiled = _.template(tmpl);
    $("main").html(compiled({product:_this.product, vulns:_this.vulns, eols:_this.eols, affects_hosts:_this.affects_hosts}));
    document.title = _this.product.name + "- SIDfm 製品";
    $('._hostname').find('[data-toggle="tooltip"]').tooltip();
  };

  _this.update_page = function(){
    $(".j_dt1").text(_this.dt1.toISOString().substr(0,10).replace(/-/g, "/"));
    $(".j_dt2").text(_this.dt2.toISOString().substr(0,10).replace(/-/g, "/"));
  };

  _this.update_crossfilter = function(vulns){
    _this.cf_vulns.add(vulns);
  };

  _this.make_crossfilter = function(){
    _this.cf_vulns = crossfilter(_this.vulns);

    _this.dm_vuln_date = _this.cf_vulns.dimension(function(d){return d.affect_create_datetime})
    var xunit = d3.timeMonth;
    _this.gr_vuln_date = _this.dm_vuln_date.group(function(d){return xunit(d)});

    _this.dm_max_cvss3 = _this.cf_vulns.dimension(function(d){return d.max_cvss3.base_score_i;});
    _this.gr_max_cvss3 = _this.dm_max_cvss3.group();

    _this.dm_cvss3 = _this.cf_vulns.dimension(function(d){
      var vals;
      var map = SidCvss3Map;
      if(d.max_cvss3.base_score > -1){
        vals = [
          "AV:" + map.metric_value_name(d.max_cvss3, "av"),
          "AC:" + map.metric_value_name(d.max_cvss3, "ac"),
          "PR:" + map.metric_value_name(d.max_cvss3, "pr"),
          "UI:" + map.metric_value_name(d.max_cvss3, "ui"),
          "S:"  + map.metric_value_name(d.max_cvss3, "s"),
          "C:"  + map.metric_value_name(d.max_cvss3, "c"),
          "I:"  + map.metric_value_name(d.max_cvss3, "i"),
          "A:"  + map.metric_value_name(d.max_cvss3, "a"),
        ];
      }else{
        vals = ["AV:未評価", "AC:未評価", "PR:未評価", "UI:未評価", "S:未評価", "C:未評価", "I:未評価", "A:未評価"];
      }
      return vals;
    });
    _this.gr_cvss3 = _this.dm_cvss3.group();

    _this.dm_max_cvss2 = _this.cf_vulns.dimension(function(d){return d.max_cvss2.base_score_i});
    _this.gr_max_cvss2 = _this.dm_max_cvss2.group();

    _this.dm_cvss2 = _this.cf_vulns.dimension(function(d){
      var vals;
      var map = SidCvss2Map;
      if(d.max_cvss2.base_score > -1){
        vals = [
          "AV:" + map.metric_value_name(d.max_cvss2, "av"),
          "AC:" + map.metric_value_name(d.max_cvss2, "ac"),
          "Au:" + map.metric_value_name(d.max_cvss2, "au"),
          "C:"  + map.metric_value_name(d.max_cvss2, "c"),
          "I:"  + map.metric_value_name(d.max_cvss2, "i"),
          "A:"  + map.metric_value_name(d.max_cvss2, "a"),
        ];
      }else{
        vals = ["AV:未評価", "AC:未評価", "Au:未評価", "C:未評価", "I:未評価", "A:未評価"];
      }
      return vals;
    });
    _this.gr_cvss2 = _this.dm_cvss2.group();

    _this.dm_area_risk1 = _this.cf_vulns.dimension(function(d){return [d.area.name, d.risk.name]});
    _this.gr_area_risk1 = _this.dm_area_risk1.group();

    _this.dm_area_risk2 = _this.cf_vulns.dimension(function(d){return [d.area.name, d.risk.name]});
    _this.gr_area_risk2 = _this.dm_area_risk2.group();
  };

  _this.render_charts = function(){

    var xunits = d3.timeMonths;
    var xscale = d3.scaleTime().domain([_this.dt1, _this.dt2]);
    var gr_top = _this.gr_vuln_date.top(1)[0]
    var ymax = gr_top == null ? 10 : gr_top.value;
    if(ymax < 10){
      ymax = 10;
    }
    var yscale = d3.scaleLinear().domain([0, ymax]);
    if(_this.chart_vuln_date === undefined){
      _this.chart_vuln_date = dc.barChart("#vuln_date_bar_chart");
      _this.chart_vuln_date
        .width(900).height(150)
        .dimension(_this.dm_vuln_date)
        .group(_this.gr_vuln_date)
        .on("filtered", function(chart, filter){_this.render_vulns()})
        .renderHorizontalGridLines(true)
      ;
    }
    _this.chart_vuln_date
      .x(xscale)
      .y(yscale)
      .xUnits(xunits)
    ;
    _this.chart_vuln_date.margins().right = 10;

    var tick_unit = 1;
    var tick_interval = d3.timeMonth;
    var xaxis_date_format = d3.timeFormat("%Y/%m");
    _this.chart_vuln_date.xAxis()
      .tickFormat(function(v){return xaxis_date_format(v)})
    ;
    _this.chart_vuln_date.yAxis()
      .ticks(10)
    ;

    var group_maxs = [_this.gr_max_cvss3.top(1), _this.gr_max_cvss3.top(1), _this.gr_area_risk1.top(1)];
    var xmax = d3.max(group_maxs, function(d){return d[0] == null ? 0 : d[0].value});
    if(xmax < 10){
      xmax = 10;
    }
    var rowchart_xscale = d3.scaleLinear().domain([0, xmax]).range([0,200]);

    var get_key = dc.pluck("key");
    var get_data = function(group){ 
      var sum = group.all();
      var data = [];
      [10,9,8,7,6,5,4,3,2,1,0,-1].forEach(function(score){data.push({key:score, value:0})});
      sum.forEach(function(d){data[10-d.key].value = d.value});
      return data;
    };
    if(_this.chart_cvss3_score === undefined){
      _this.chart_cvss3_score = dc.rowChart("#cvss3_score_row_chart");
      _this.chart_cvss3_score
        .width(250).height(250)
        .ordering(function(d){return -get_key(d)})
        .dimension(_this.dm_max_cvss3)
        .group(_this.gr_max_cvss3)
        .data(get_data)
        .colors(function(d){return SidColors.cvss[d]})
        .label(function(d){return d.key >= 0 ? d.key : "未評価"})
        .on("filtered", function(chart, filter){_this.render_vulns()});
      ;
    }
    _this.chart_cvss3_score
      .x(rowchart_xscale)
    ;

    if(_this.chart_cvss3 === undefined){
      _this.chart_cvss3 = dc.sunburstChart("#cvss3_sunburst_chart");
      _this.chart_cvss3
        .width(250).height(250).innerRadius(40)
        .dimension(_this.dm_cvss3)
        .group(_this.gr_cvss3)
        .colors(function(d){return _this.cvss3_color_map[d]})
        .on("filtered", function(chart, filter){_this.render_vulns()});
      ;
    }

    if(_this.chart_cvss2_score === undefined){
      _this.chart_cvss2_score = dc.rowChart("#cvss2_score_row_chart");
      _this.chart_cvss2_score
        .width(250).height(250)
        .ordering(function(d){return -get_key(d)})
        .dimension(_this.dm_max_cvss2)
        .group(_this.gr_max_cvss2)
        .data(get_data)
        .colors(function(d){return SidColors.cvss[d]})
        .label(function(d){return d.key >= 0 ? d.key : "未評価"})
        .on("filtered", function(chart, filter){_this.render_vulns()});
      ;
    }
    _this.chart_cvss2_score
      .x(rowchart_xscale)
    ;

    if(_this.chart_cvss2 === undefined){
      _this.chart_cvss2 = dc.sunburstChart("#cvss2_sunburst_chart");
      _this.chart_cvss2
        .width(250).height(250).innerRadius(50)
        .dimension(_this.dm_cvss2)
        .group(_this.gr_cvss2)
        .colors(function(d){return _this.cvss2_color_map[d]})
        .on("filtered", function(chart, filter){_this.render_vulns()});
      ;
    }

    if(_this.chart_area_risk === undefined){
      _this.chart_area_risk = dc.rowChart("#area_risk_row_chart");
      _this.chart_area_risk
        .width(250).height(250)
        .dimension(_this.dm_area_risk1)
        .group(_this.gr_area_risk1)
        .data(function(group){
          var sum = group.all();
          var data = [];
          var idx = 0;
          var key_idx = {};
          ["リモート", "クライアント", "ローカル"].forEach(function(area_name){
            ["重大", "高", "中", "低"].forEach(function(risk_name, idx_risk){
              data.push({key:[area_name, risk_name], value:0})
              if(key_idx[area_name] === undefined){key_idx[area_name] = {}}
              key_idx[area_name][risk_name] = idx;
              idx++;
            })
          })
          sum.forEach(function(d){
            if(d.key[0] === "未定義"){return}
            var idx = key_idx[d.key[0]][d.key[1]];
            data[idx].value = d.value;
          });
          return data;
        })
        .colors(function(d){return _this.sid_color_map[d[1]]})
        .on("filtered", function(chart, filter){_this.render_vulns()});
      ;
    }
    _this.chart_area_risk
      .x(rowchart_xscale)
    ;

    if(_this.chart_area_risk_sb === undefined){
      _this.chart_area_risk_sb = dc.sunburstChart("#area_risk_sunburst_chart");
      _this.chart_area_risk_sb
        .width(250).height(250).innerRadius(60)
        .dimension(_this.dm_area_risk2)
        .group(_this.gr_area_risk2)
        .colors(function(d){return _this.sid_color_map[d]})
        .on("filtered", function(chart, filter){_this.render_vulns()});
      ;
    }

    dc.renderAll();
  };

  _this.render_vulns = function(){
    if(_this.compiled_vulns_template == null){
      var tmpl = $("#vuln_template").html();
      _this.compiled_vuln_template = _.template(tmpl);
    }
    var vulns = _this.dm_vuln_date.top(Infinity);
    var j_vulns = $("#vulns");
    //j_vulns.empty();
    var htmlids = [];
    vulns.forEach(function(vuln){
      htmlids.push(vuln.id);
    });
    var htmlids2issue_req = $.post($('#sidfm_informations_api_htmlids2issue_path').val(), { html_ids:htmlids }, function(res) {_this.htmlids2issue = res;});
    $.when(htmlids2issue_req).done(function() {
      j_vulns.empty();
      vulns.forEach(function(vuln){
        j_vulns.append(_this.compiled_vuln_template({vuln:vuln, htmlids2issue:_this.htmlids2issue}));
      });
    });
    $(".j_vuln_count").text(vulns.length);
  };

  _this.bind_event = function(){
    $(".j_lazy_load_switch").on("click", function(){_this.click_lazy_load_switch(this)});
    $(".j_eols_vers_switch").on("click", function(){_this.click_eols_vers_switch(this)});
    $(".j_affects_hosts_switch").on("click", function(){_this.click_affects_hosts_switch(this)});
    $(".j_reset_switch").on("click", function(){_this.click_reset_switch(this)});
    $('[data-toggle="tooltip"]').tooltip();
  };

  _this.click_lazy_load_switch = function(elm){
    var j_elm = $(elm);
    var elm = j_elm.get(0);
    var j_indicator = $(".j_load_indicator");
    if(_this.lazy_load_disabled !== true){
      _this.lazy_load_disabled = true;
      j_indicator.removeClass("_loading").addClass("_pausing")
      var pause_text = j_elm.text();
      elm.dataset.pauseText = pause_text;
      var continue_text = elm.dataset.continueText;
      j_elm.text(continue_text);
      clearTimeout(_this.lazy_load_id);
    }else{
      _this.lazy_load_disabled = false;
      j_indicator.removeClass("_pausing").addClass("_loading")
      var pause_text = elm.dataset.pauseText;
      j_elm.text(pause_text);
      _this.lazy_load_id = setTimeout(_this.lazy_load, 1000);
    }
  };

  _this.click_eols_vers_switch = function(elm){
    var j_icon = $(".j_eols_vers_switch_icon");
    var j_eols_vers = $(".j_eols_vers_box");
    if(j_eols_vers.css("display") === "none"){
      j_eols_vers.show();
      j_icon.html("&#x229f;");
    }else{
      j_eols_vers.hide();
      j_icon.html("&#x229e;")
    }
  };

  _this.click_affects_hosts_switch = function(elm){
    var j_icon = $(".j_affects_hosts_switch_icon");
    var j_affects_hosts = $(".j_affects_hosts_box");
    if(j_affects_hosts.css("display") === "none"){
	  j_affects_hosts.show();
	  j_icon.html("&#x229f;");
    }else{
      j_affects_hosts.hide();
      j_icon.html("&#x229e;")
    }
  };

  _this.click_reset_switch = function(elm){
    dc.filterAll(null);
    dc.renderAll();
  };

  return _this;
})();

$(function(){
  "use strict";
  product_box.show();
});
