/* coding: utf-8 */

//BootStrapTableのtdのスタイル。画面ごとに関数を作って設定する
function BootStrapTableCellStyle(value, row, index, field) {
    switch (field){
    case 'chkbox':
        return { classes: 'chk-box' };
    case 'ipaddress':
        return { classes: 'ipaddress' };
    case 'hostname':
	return { classes: 'hostname' };
    case 'datekey':
	return { classes: 'datekey' };
    case 'is_ssh':
	return { classes: 'is_ssh' };
    case 'is_nmap':
	return { classes: 'is_nmap' };
    case 'is_ping':
	return { classes: 'is_ping' };
    case 'os':
	return { classes: 'os' };
    case 'pkgs':
	return { classes: 'pkgs' };
    case 'edit':
        return { classes: 'edit' };
    default:
        return { classes: '' };
    }
}

$(function() {
    activate_sidebar_item('sidebar-item-probes-manip');

    const summaryTableId = 'probes-summary-table';
    const summaryTableElm = $('#' + summaryTableId);
    const pageName = 'probes';

    adjust_balloon_dropdown_style();

    function get_probe_apikey_id() {
	filters = JSON.parse($('#pages_filters').val());
	return filters['probe_apikey_id'];
    }

    // ホスト登録
    const enableCreateHost = () => {
	$('#' + summaryTableId + ' [data-create="true"]').on('click', function() {
	    const button = $(this);
	    const data = button.data();
	    const probe_apikey_id = data['probeapikeyid'];
	    const ipaddress = data['ipaddress'];
	    const hostname = data['hostname'];
	    (async () => {
		$('#regist-probeapikeyid').val(probe_apikey_id);
		$('#regist-hostname').val(hostname);
		$('#regist-ipaddress').val(ipaddress);
		$('#hostname-input').val(hostname);
		$('#modalRegist').modal('show');
	    })();
	});
    };
    // 紐づけ
    const SearchedHostsArea = $('#modalEditSearchedHostsArea');
    const SearchedHostsInfo = { fetching: null };
    const selectedHostIdElm = $('#edit-hostid');
    function toggleEditButton() {
	let isInvalid = !selectedHostIdElm.val().length;
	$('#exec-edit').prop('disabled', isInvalid);
    }
    const enableRelateHost = () => {
	$('#' + summaryTableId + ' [data-edit="true"]').on('click', function() {
	    const button = $(this);
	    const data = button.data();
	    const probe_apikey_id = data['probeapikeyid'];
	    const ipaddress = data['ipaddress'];
	    (async () => {
		$('#edit-probeapikeyid').val(probe_apikey_id);
		$('#edit-ipaddress').val(ipaddress);
		toggleEditButton();
		$('#modalEdit').modal('show');
	    })();
	});
    };

    // 紐づけ削除
    const enableDeleteHost = () => {
	$('#' + summaryTableId + ' [data-delete="true"]').on('click', function() {
	    (async () => {
		$('body').append(create_loading_window());
		var button = $(this);
		var data = button.data();
		var probe_apikey_id = data['probeapikeyid'];
		var ipaddress = data['ipaddress'];
		var host_id = data['hostid'];
		var paramsData = {
		    probe_apikey_id: probe_apikey_id,
		    ipaddress: ipaddress,
		    sidfmd_host_id: host_id
		};
		var action = $('#get-delete-path').val();
		var confirmed = confirm(`${ipaddress}の紐づけを削除します。よろしいですか？\nなお、紐づけ先のホストが削除されることはありません。`);
		if (!confirmed) {
		    $('#checking-window').remove();
		    return;
		}
		dynamicSummaryTable.executeProcess({
		    paramsData,
		    path: action,
		    additionalAlertMessage: '紐づけの削除に失敗しました。'
		});
		$('#checking-window').remove();
		return false;
	    })();
	});
    };

    //サマリー表の動的処理のため(bootstrap-tableのため)にbindする。でないとイベントが効かない。
    const bindSummaryTableRowEvents = () => {
        enable_bootstrap_actions('#' + summaryTableId);
	enableCreateHost();
	enableRelateHost();
	enableDeleteHost();
    };

    const dynamicSummaryTable = new DynamicSummaryTable({
	summaryTableId,
	bindSummaryTableRowEventsFunction: bindSummaryTableRowEvents,
	pageName,
	allFilteredIdsId: 'all-probe-ids',
	ChkboxValueType: 'string',
	chkboxSelector: `#${summaryTableId} .probeSelect`,
	allChkboxSelector: `#${summaryTableId} .allProbeSelect`,
        bulkBtnSelector: '.action-btn',
        checkRolesAndCatsFlgElm: $('#check-roles-cats-flg'),
        checkUserInfoTarget: 'auth'
    });

    set_style_for_ActionArea_on_filter_dropdown_event();
    sticky_control('SummaryTableButtonsArea', pageName);
    $('#pages_form').on('submit', function(){ set_summary_table_lines(pageName, $('#pages_per_page').val())});

    // 検索
    const summaryTableFilter = new SummaryTableFilter({dynamicSummaryTable});
    summaryTableFilter.enableFilterChangeLink('.probe-apikey-change'); // apikey選択
    summaryTableFilter.enableFilterChangeLink('.filter-change');
    summaryTableFilter.enableResetAllFilters('#filter-clear');


    // 一括処理で使用する共通処理
    const createBulkTrElm = (row) => {
	let tr = $('<tr>');
	tr.append($('<td>').attr('class', 'text-left text-break').text(row['ipaddress']));
	tr.append($('<td>').attr('class', 'text-left text-break').text(row['hostname']));
	return tr;
    };

    // 一括ホスト登録
    $('#modalBulkRegist').on('hide.bs.modal', function() {
	$('#modalBulkRegistTbody').closest('.modal-mail-table').scrollTop(0);
    });
    $('#bulk-create-hosts').on('click', function() {
	let probe_apikey_id = get_probe_apikey_id();
	let checked = JSON.parse($('#pages_checked').val());
	$('#prefix-input').val('');
	$('#suffix-input').val('');
	$('#bulk-regist-ids').val(JSON.stringify(checked));
	(async () => {
	    $.post($('#api-get-ip-hostname-regist-path').val(), { ips: JSON.stringify(checked), probe_apikey_id: probe_apikey_id }, function(rows) {
		if (rows.length == 0) {
		    alert('ホスト登録できる対象がありません。');
		    return;
		}
		$('#modalBulkRegistTbody *').remove();
		const sliceNum = 20;
		let rowElms = [];
		const target = $('#modalBulkRegistTbody');
		rows.slice(0, sliceNum).forEach(row => rowElms.push(createBulkTrElm(row)));
		target.append(rowElms);
		$('#modalBulkRegist').modal('show');
		setTimeout(function() {
		    rows.slice(sliceNum).forEach(row => target.append(createBulkTrElm(row)));
		});
	    })
	})();
    });

    $('#exec-bulk-regist').on('click', function() {
	const confText = '一括ホスト登録を行います。よろしいですか？';
	const br_ids = JSON.parse($('#bulk-regist-ids').val());
	const probe_apikey_id = get_probe_apikey_id();
	const prefix = $('#prefix-input').val();
	const suffix = $('#suffix-input').val();
	const iphost = $('#iphost-select').val(); // ip or hostname
	const button = $(this);
	button.addClass('pointert-events-none');
	const cancel = () => {
	    button.removeClass('pointer-events-none');
	    $('#checking-window').remove();
	};
	(async () => {
	    $.post($('#api-get-generate-hostnames-path').val(),
		   { probe_apikey_id: probe_apikey_id,
		     ips: JSON.stringify(br_ids),
		     prefix: prefix,
		     suffix: suffix,
		     iphost: iphost }, function(ips) {
			 console.log(ips);
			 if (ips.length == 0) {
			     alert('エラーが発生しました。ホスト名が不正な可能性があります。入力内容をご確認下さい。');
			     cancel();
			     return;
			 }
			 $.post($('#api-check-duplicate-hostnames-path').val(),
				{ hostnames: JSON.stringify(ips.map((x) => x['hostname']) ) },
				function(hostnames) {
				    if (hostnames.length == 0) {
					let conf = confirm(confText);
					if (!conf) {
					    cancel();
					    return;
					}
					ids = ips;
					dynamicSummaryTable.executeProcessWithProgressBar({
					    ids,
					    paramsData: {
						probe_apikey_id: probe_apikey_id,
					    },
					    idsParamsName: 'ips',
					    path: $('#api-regist-path').val()
					});
				    } else  {
					alert('ホスト名が重複しているため、登録に失敗しました。\n入力内容をご確認の上、再実行してください。');
				    }
				    cancel();
				});

		     });
	})();
			      
    });
			      

    // 一括紐づけ削除
    $('#modalBulkDelete').on('hide.bs.modal', function() {
	$('#modalBulkDeleteTbody').closest('.modal-mail-table').scrollTop(0);
    });

    $('#bulk-remove-relations').on('click', function() {
	let probe_apikey_id = get_probe_apikey_id();
	let checked = JSON.parse($('#pages_checked').val());
	$('#bulk-delete-ids').val(JSON.stringify(checked));
	(async () => {
	    $.post($('#api-get-ip-hostname-path').val(), { ips: JSON.stringify(checked), probe_apikey_id: probe_apikey_id }, function(rows) {
		if (rows.length == 0) {
		    alert('紐づけ削除できる対象がありません。');
		    return;
		}
		$('#modalBulkDeleteTbody *').remove();
		const sliceNum = 20;
		let rowElms = [];
		const target = $('#modalBulkDeleteTbody');
		rows.slice(0, sliceNum).forEach(row => rowElms.push(createBulkTrElm(row)));
		target.append(rowElms);
		$('#modalBulkDelete').modal('show');
		setTimeout(function() {
		    rows.slice(sliceNum).forEach(row => target.append(createBulkTrElm(row)));
		});
	    });
	})();
    });

    $('#exec-bulk-delete').on('click', function() {
	const confText = '紐づけを一括削除します。紐づけ先のホストは削除されません。よろしいですか？';
	const ids = JSON.parse($('#bulk-delete-ids').val());
	const probe_apikey_id = get_probe_apikey_id();
	const button = $(this);
	button.addClass('pointer-events-none');
	const cancel = () => {
	    button.removeClass('pointer-events-none');
	    $('#checking-window').remove();
	};
	(async () => {
	    $('body').append(create_loading_window());
	    let conf = confirm(confText);
	    if (!conf) {
		cancel();
		return;
	    }
	    dynamicSummaryTable.executeProcessWithProgressBar({
		ids,
		paramsData: { probe_apikey_id: probe_apikey_id },
		idsParamsName: 'ips',
		path: $('#api-bulk-delete-path').val()
	    });
	    cancel();
	})();
	
    });

    // ホスト登録でホスト名を設定するボタンのaction設定
    $('#set-hostname-to-hostname').on('click', function() {
	(async () => {
	    $('#hostname-input').val($('#regist-hostname').val());
	})();
    });
    $('#set-hostname-to-ipaddress').on('click', function() {
	(async () => {
	    $('#hostname-input').val($('#regist-ipaddress').val());
	})();
    });

    // ホスト登録の実行
    $('#exec-regist').on('click', function() {
	const confText = 'ホスト登録を行います。よろしいですか？';
	const button = $(this);
	button.addClass('pointer-events-none');
	const probeapikeyid = $('#regist-probeapikeyid').val();
	const ipaddress = $('#regist-ipaddress').val();
	const hostname = $('#hostname-input').val();
	const cancel = () => {
	    button.removeClass('pointer-events-none');
	    $('#checking-window').remove();
	};
	(async () => {
	    $('body').append(create_loading_window());
	    $.post($('#api-check-duplicate-hostnames-path').val(),
		   { hostnames: JSON.stringify([ hostname ]) },
		   function(hostnames) {
		       if (hostnames.length == 0) {
			   let conf = confirm(confText);
			   if (!conf) {
			       cancel();
			       return;
			   }
			   ids = [ { ipaddress: ipaddress, hostname: hostname } ];
			   dynamicSummaryTable.executeProcessWithProgressBar({
			       ids,
			       paramsData: {
				   probe_apikey_id: probeapikeyid
			       },
			       idsParamsName: 'ips',
			       path: $('#api-regist-path').val()
			   });
		       } else {
			   alert("ホスト名が重複しているため、登録に失敗しました。\nホスト名を変更して再実行してください。");
		       }
		       cancel();
		   });
	})();
    });

    // ホスト紐づけの実行
    $('#exec-edit').on('click', function() {
	const confText = 'ホスト紐づけを行います。よろしいですか？';
	const button = $(this);
	button.addClass('pointer-events-none');
	const probeapikeyid = $('#edit-probeapikeyid').val();
	const ipaddress = $('#edit-ipaddress').val();
	const hostid = $('#edit-hostid').val();
	const cancel = () => {
	    button.removeClass('pointer-events-none');
	    $('#checking-window').remove();
	};
	(async () => {
	    $('body').append(create_loading_window());
	    let conf = confirm(confText);
	    if (!conf) {
		cancel();
		return;
	    }
	    $('body').append(create_loading_window());
	    ids = [ { ipaddress: ipaddress, hostid: hostid } ];
	    dynamicSummaryTable.executeProcessWithProgressBar({
		ids,
		paramsData: {
		    probe_apikey_id: probeapikeyid
		},
		idsParamsName: 'ips',
		path: $('#api-edit-path').val()
	    });
	    cancel();
	})();
    });

    // ホスト名検索
    // ホスト紐づけで使用
    $('#edit-hostname-input').on('input', function() {
	const name = $(this).val();
	SearchedHostsArea.html('');
	selectedHostIdElm.val('');
	toggleEditButton();
	if (SearchedHostsInfo.fetching) {
	    SearchedHostsInfo.fetching.abort();
	}
	SearchedHostsInfo.fetching = $.post($('#api-search-hostnames-path').val(), { hostname: name }, function(hosts) {
	    const hostElms = hosts.map(host => {
		return $('<div>').addClass('searched-hostname').attr({
		    'data-hostid': host.id,
		    'data-hostname': host.hostname
		}).text(host.displayname ? host.hostname + ' ' + host.displayname : host.hostname);
	    });
	    if (hostElms.length) {
		$('#edit-input-tooltip').tooltip('hide');
		SearchedHostsArea.show().append(hostElms);
		SearchedHostsArea.find('[data-hostid]').on('click', function() {
		    $('#edit-hostname-input').val($(this).attr('data-hostname'));
		    selectedHostIdElm.val($(this).attr('data-hostid'));
		    SearchedHostsArea.hide();
		    toggleEditButton();
		});
	    } else {
		$('#edit-input-tooltip').tooltip(name.length ? 'show' : 'hide');
		SearchedHostsArea.hide();
	    }
	});
    });


});
