/* coding: utf-8 */
/* Copyright (C) 2021 SofTek Systems, Inc. */

$(function(){
    init_sidfm();
    enable_dropdown_balloon();

    $('.cancel-import').on('click', function(){
        location.href = $('#index-page-path').val()
    });

    function display_unchangeable_users(users){
        $('#UnchangeableUsersModalTbody > *').remove();
        $('#UnchangeableUsersModalDescription').text(
            '以下のユーザのインポートを行うと、ログインユーザのカテゴリ範囲外のルールの条件、操作もしくはルール自体が削除されるため、インポートの処理を実行することができません。'
        );
        var num = 15;
        var append_row = function(user){
            var tr = $('<tr>').append(
                $('<td>').text(user['login']),
                $('<td>').text(user['lastname'] + ' ' + user['firstname']),
                $('<td>').text(user['mail'])
            );
            $('#UnchangeableUsersModalTbody').append(tr);
        };
        users.slice(0, num).forEach(function(user){ //すぐに表示されるように、はじめに表示分だけappend
            append_row(user);
        });

        $('#UnchangeableUsersModal').modal('show');

        users.slice(num, users.length).forEach(function(user){
            append_row(user);
        });
    }

    function exec_import(){
        var import_apply_path = $('#import-apply-path').val();
        var actions = JSON.parse($('#actions').val());

        var progress_window = get_progress_bar();
        $('body').append(progress_window);

        var percentage = 0;
        var executed_actions = 0;
        var total_actions = actions.length;
        var err_messages = new Set();
        var err_cnt = 0;
        var cnt = 0;
        var process_rules = true;

        var delete_user_ids = $('#delete_user_ids').val();
        var category_change_user_categoryids = $('#category_change_user_categoryids').val();
        var change_role_user_ids = $('#change_role_user_ids').val();
        var change_user_group_ids = $('#change_user_group_ids').val();
 
        var import_apply = function(){
            var action = actions[cnt];
            if ( process_rules ){
                var param_data = {
                    'action_data' : JSON.stringify(action),
                    'process_rules': process_rules,
                    'delete_user_ids': delete_user_ids,
                    'category_change_user_categoryids': category_change_user_categoryids,
                    'change_role_user_ids': change_role_user_ids,
                    'user_cat_group_ids': change_user_group_ids,
                };
            }else{
                var param_data = { 'action_data' : JSON.stringify(action) };
            }
            $.ajax({
                url: import_apply_path,
                type: 'POST',
                data: param_data
            }).done(function(res){
                process_rules = false; //ルールは初めに処理する。
                if( res['rules_error'] ){
                    alert(res['err_message']);
                    location.href = $('#index-page-path').val();
                    return false;
                }
                cnt += 1;
                err_message = res['err_message'];
                if( err_message.length > 0 ){
                    err_messages.add(err_message);
                    err_cnt += 1;
                }
                executed_actions += 1;
                var percentage = (executed_actions / total_actions) * 100;
                if( percentage >= 99 && percentage < 100 ){
                    percentage = 99;
                }else{
                    percentage = Math.round(percentage);
                }
                $('#progress-bar').attr('aria-valuenow', percentage).css('width', (percentage < 3 ? 3 : percentage) + '%').text(percentage + '%');
                if( percentage == 100 ){
                    setTimeout(function(){//progress barのbarが満たされるまで待つ
                        if(err_messages.size > 0){
                            err_messages = Array.from(err_messages);
                            alert(err_messages.join('\n') + (err_cnt == total_actions ? '' : '\n※他のデータ登録は完了しています。') + '\nユーザ管理画面に移動します。');
                            location.href = $('#index-page-path').val();
                        }else{
                            location.href = $('#index-page-path').val();
                        }
                    },800);
                }else{
                    import_apply();
                }
            });
        };

        import_apply();
    }

    //インポート実行時に、関連するルールを表示
    $('.execute-import').on('click', function(){
        var check_rules_path = $('#sidfm_internal_api_check_related_rules_path').val();
        $('body').append(create_loading_window());
        var delete_user_ids = $('#delete_user_ids').val();
        var category_change_user_categoryids = $('#category_change_user_categoryids').val();
        var change_role_user_ids = $('#change_role_user_ids').val();
        var change_user_group_ids = $('#change_user_group_ids').val(); 
        
        //変更先権限が閲覧者で、且つVmApikeyにユーザが設定されていて、更新許可がtrueになっていているものをチェック
        $.post(
            $('#api_get_vm_apikey_related_users_path').val(),
            { user_role_ids: change_role_user_ids, delete_user_ids },
            function(apikey_related_users){
                const not_allowed_users = apikey_related_users.not_allowed_allow_update_true_users;
                const delete_role_apikey_users = apikey_related_users.delete_role_apikey_users; 
                const delete_apikey_users = apikey_related_users.delete_apikey_users;
                const apikey_users = apikey_related_users.all_related_users;
                /*apikey_users.sort((a, b) => {
                    if(a.login.toLowerCase() < b.login.toLowerCase()){
                       return -1;
                    }else{
                       return 1;
                    }
                });*/
                const label = $('#vm-apikey-allow-update-label').val();
                let conf_text = '';
                if( not_allowed_users.length && delete_role_apikey_users.length && delete_apikey_users.length ){
                    conf_text = `変更を実行すると、以下のユーザのうち、SIDfmVM閲覧者権限が設定される全てのSIDfmVM APIキーの${label}の項目が「不許可」に変更され、削除されるユーザと権限が削除されるユーザが設定されている、全てのSIDfmVM APIキーが削除されます。よろしいですか?\n` +
                        'ログイン名:\n' +
                        apikey_users.map(user => user.login).join('\n');
                }else if(not_allowed_users.length && delete_role_apikey_users.length){
                    conf_text = `変更を実行すると、以下のユーザのうち、SIDfmVM閲覧者権限が設定される全てのSIDfmVM APIキーの${label}の項目が「不許可」に変更され、権限が削除されるユーザが設定されている全てのSIDfmVM APIキーが削除されます。よろしいですか?\n` +
                        'ログイン名:\n' +
                        apikey_users.map(user => user.login).join('\n');
                }else if(not_allowed_users.length && delete_apikey_users.length){
                    conf_text = `変更を実行すると、以下のユーザのうち、SIDfmVM閲覧者権限が設定される全てのSIDfmVM APIキーの${label}の項目が「不許可」に変更され、削除されるユーザが設定されている全てのSIDfmVM APIキーが削除されます。よろしいですか?\n` +
                        'ログイン名:\n' +
                        apikey_users.map(user => user.login).join('\n');
                }else if(delete_role_apikey_users.length && delete_apikey_users.length){
                    conf_text = `変更を実行すると、以下の削除されるユーザと権限が削除されるユーザが設定されている、全てのSIDfmVM APIキーが削除されます。よろしいですか?\n` +
                        'ログイン名:\n' +
                        apikey_users.map(user => user.login).join('\n');
                }else if(not_allowed_users.length){
                    conf_text = `変更を実行すると、以下のSIDfmVM閲覧者権限が設定されるユーザの設定されている、全てのSIDfmVM APIキーの${label}の項目が「不許可」に変更されます。よろしいですか?\n` +
                        'ログイン名:\n' +
                        apikey_users.map(user => user.login).join('\n');
                }else if(delete_apikey_users.length){
                    conf_text =  '変更を実行すると、以下の削除されるユーザの設定されている、全てのSIDfmVM APIキーが削除されます。よろしいですか?\n' +
                        'ログイン名:\n' +
                        apikey_users.map(user => user.login).join('\n');
                }else if(delete_role_apikey_users.length){
                    conf_text = '変更を実行すると、以下の権限が削除されるユーザの設定されている、全てのSIDfmVM APIキーが削除されます。よろしいですか?\n' + 
                        'ログイン名:\n' +
                        apikey_users.map(user => user.login).join('\n');
                }
                if( conf_text ){
                    let conf = confirm(conf_text);
                    if( !conf ){
                        $('#checking-window').remove();
                        return false;
                    }
                }
                $.ajax({
                    url: check_rules_path,
                    type: 'POST',
                    data: { 
                        'page_name': 'user',
                        'user_ids': delete_user_ids, 
                        'user_categoryids': category_change_user_categoryids,
                        'user_role_ids': change_role_user_ids,
                        'user_cat_group_ids': change_user_group_ids,
                        'action_idx': 'import'
                    },
                }).done(function(data){
                    $('#checking-window').remove();
                    if( data['is_unchangeable_user'] ){
                        display_unchangeable_users(data['unchangeable_users']);
                    }else{
                        if(Object.keys(data['rule_messages']).length > 0){
                            display_related_rules(data);
                        }else{
                            exec_import();
                        }
                    }
                });
            }
        );

    });

    $('#submit-related-rules-item-form').on('click', function(){
        exec_import();
    });

});
