var vuln_box = (function(){
  "use strict";
  var vuln_box = {};
  var _this = vuln_box;

  _this.init = function(opts){
    _this.versions = {};
    _this.vuln_content = {};
    _this.vuln_tab = "description";
    _this.color_map = SidColors;
  };

  function start_process(){
      try{
        _this.render_vuln();
        _this.render_vuln_content();
        _this.bind_event();
      }catch{
        alert('コンテンツが無いため、表示できません。');
        location.href = $('#vuln-list-path').val();
        return false;
      }
      var location_hash = location.hash;
      if(/^#CVE-\d+-\d+$/i.test(location_hash)){
        $(location_hash).closest(".subtitle").find("a:contains(" + location_hash.substr(1) + ")").addClass("_target_cve");
        $(".j_vuln_content").ready(function(){_this.scroll_to(location_hash)});
      }
      var categories_descriptions = JSON.parse($('#categories-desc').val());
      categories_descriptions.forEach(function(cat){
          $('#sri-category-' + cat.id).attr({
              'data-toggle': 'tooltip',
              'data-title': cat.desc,
              'data-placement': 'top',
              'data-boundary': 'window'
          }).tooltip();
      });
  }
  _this.show = function(opts){
      _this.init();
      var vuln_id = parseInt($('#id').val());
      var is_local_vuln = JSON.parse($('#is-local-vuln').val());
      if( is_local_vuln ){
          var local_vuln = JSON.parse($('#local-vuln').val());
          var areas = JSON.parse($('#areas').val());
          var risks = JSON.parse($('#risks').val());
          var sri_categories = JSON.parse($('#sri-categories').val());
          _this.vuln = local_vuln;
          _this.areas = areas;
          _this.risks = risks;
          _this.cats = sri_categories;
          _this.htmlids2issue = {};
          /*console.log(vuln_id)
          console.log(_this.vuln)
          console.log(_this.areas)
          console.log(_this.risks)
          console.log(sri_categories) */
          start_process();
      }else{
          var vuln_req = $.post($('#sidfm_internal_api_info_vuln_path').val(), {id:vuln_id}, function(res){ _this.vuln = res.vuln;});
          var areas_req = $.post($('#sidfm_internal_api_info_areas_path').val(), function(res){ _this.areas = res.areas;});
          var risks_req = $.post($('#sidfm_internal_api_info_risks_path').val(), function(res){_this.risks = res.risks;});
          var cats_req = $.post($('#sidfm_internal_api_info_sri_categories_path').val(), function(res){_this.cats = res.sri_categories;});
          var htmlids2issue_req = $.post($('#sidfm_informations_api_htmlids2issue_path').val(), {html_ids:[vuln_id]}, function(res){_this.htmlids2issue = res;});
          $.when(vuln_req, areas_req, risks_req, cats_req, htmlids2issue_req).done(function(){
              start_process();
          });
      } 
  };

  _this.scroll_to = function(hash){
    if($(hash).offset() && /^#[A-Za-z0-9\-_]+$/.test(hash)){
      var jh1 = $("h1:first");
      var h = jh1.offset().top + jh1.outerHeight();
      $("html,body").animate({scrollTop:$(hash).offset().top - (h * 1.05)});
    }
    return false;
  };

  _this.render_vuln = function(){
      var vuln = _this.vuln;
      vuln.area = _.find(_this.areas, function(area){return area.id === _this.vuln.area_id});
      vuln.risk = _.find(_this.risks, function(risk){return risk.id === _this.vuln.risk_id});
      vuln.sris.forEach(function(sri){
        sri.category = _.find(_this.cats, function(cat){return cat.id === sri.category_id});
        sri.risk = _.find(_this.risks, function(risk){return risk.id === sri.risk_id});
      })
      vuln.create_date = vuln.create_datetime.substr(0, 10).replace(/-/g, "/");
      vuln.update_date = vuln.update_datetime.substr(0, 10).replace(/-/g, "/");
      if(vuln.create_date === vuln.update_date){
        vuln.update_date = '-'
      }
      vuln.cves.forEach(function(cve){
        if(cve.cvss2 == null){
          cve.cvss2 = {base_score:-1}
        }
        if(cve.cvss3 == null){
          cve.cvss3 = {base_score:-1}
        }
        //最大値・ソート用 //CVSS3優先
        if(cve.cvss3.base_score >= 0){
          cve.cve_cvss = cve.cvss3;
        }else if(cve.cvss2.base_score >= 0){
          cve.cve_cvss = cve.cvss2;
        }else {
          cve.cve_cvss = {base_score:-1}
        }
      });
      var max_cvss_cve = _.max(vuln.cves, function(cve){return cve.cve_cvss.base_score});
      if(max_cvss_cve.cve_cvss != null && max_cvss_cve.cve_cvss.base_score > -1){
        if(max_cvss_cve.cvss3.base_score >= 0){
          vuln.max_cvss = max_cvss_cve.cvss3;
          vuln.max_cvss.ver = 3;
          vuln.max_cvss = SidCvss3Map.parse_vector_string(vuln.max_cvss);
        }else{
          vuln.max_cvss = max_cvss_cve.cvss2;
          vuln.max_cvss.ver = 2;
          vuln.max_cvss = SidCvss2Map.parse_vector_string(vuln.max_cvss);
        }
      }else{
        vuln.max_cvss = SidCvss3Map.parse_vector_string({ver:3, base_score:-1});
      }
      var exploitable =
        _.find(vuln.cves, function(cve){
          var cvss2 = cve.cvss2 || {};
          var cvss3 = cve.cvss3 || {};
          return cvss2.exploitable || cvss3.exploitable
        });
      if(exploitable){
        vuln.exploitable = true
      }else{
        vuln.exploitable = false
      }
      vuln.sri_memos = [];
      vuln.sris.forEach(function(sri){
        var sri_memo;
        if(sri.memo != null){
          sri_memo = _.find(vuln.sri_memos, function(sri_memo){return sri_memo.memo === sri.memo});
          if(sri_memo != null){
            sri_memo.categories.push(sri.category);
          }else{
            sri_memo = {memo:sri.memo, categories:[sri.category]};
            vuln.sri_memos.push(sri_memo);
          }
        }
      });
      vuln.flg_vm = (_this.htmlids2issue != undefined && _this.htmlids2issue['' + vuln.id] > 0);

      var tmpl = $("#template").html();
      var compiled = _.template(tmpl);
      $("#vuln").html(compiled({vuln:vuln}));

      var c = new CvssRadar(".j_max_cvss_chart", vuln.max_cvss, {type:"max"});
      c.render();
      
      var cp_vuln = Object.assign({}, vuln);
      /*var create_content = function(content){
        var rows = [];
        $('<div>').html(content)
                  .text()
                  .split("\n")
                  .forEach(function(row){
                    var trimed_letters = row.trim();
                    if( trimed_letters.length > 0 ){
                      rows.push(trimed_letters);
                    }
                  });
        return rows.join("\n");
      };
      cp_vuln['content'] = {};
      cp_vuln['content']['description'] = create_content(vuln['content']['description']);
      cp_vuln['content']['affect'] = create_content(vuln['content']['affect']);
      cp_vuln['content']['verification'] = create_content(vuln['content']['verification']);
      cp_vuln['content']['solution'] = create_content(vuln['content']['solution']);
      cp_vuln['content']['link'] = create_content(vuln['content']['link']);
      cp_vuln['content']['history'] = create_content(vuln['content']['history']);*/
      cp_vuln['content'] = {};
      cp_vuln['content']['description'] = vuln['content']['description'];
      cp_vuln['content']['affect'] = vuln['content']['affect'];
      cp_vuln['content']['verification'] = vuln['content']['verification'];
      cp_vuln['content']['solution'] = vuln['content']['solution'];
      cp_vuln['content']['link'] = vuln['content']['link']
      cp_vuln['content']['history'] = vuln['content']['history'];
      //console.log(vuln.affect_products.map(function(p){return p.product;}))
      $("#vuln_info").val(JSON.stringify(cp_vuln));
      $('#wrap-ActionArea').show();
  };

  _this.cvss_jq = function(cvss, opts){
    if(opts == null){opts = {};}
    var j_box = $("<span>");
    var j_exp = $("<span>");
    if(cvss.exploitable == true){
      if(opts.size === "s"){
        j_exp.attr("class", "_cvss_exploitable_icon cvss_icon_s cvss_icon_s_img cvss_icon_s_exploitable_t");
        ;
      }else{
        j_exp.attr("class", "_cvss_exploitable_icon cvss_icon_m cvss_icon_m_img cvss_icon_m_exploitable_t");
      }
    }else{
      if(opts.size === "s"){
        j_exp.attr("class", "_cvss_exploitable_icon cvss_icon_s cvss_icon_s_img cvss_icon_s_exploitable_f");
      }else{
        j_exp.attr("class", "_cvss_exploitable_icon cvss_icon_m cvss_icon_m_img cvss_icon_m_exploitable_f");
      }
    }
    j_box.append(j_exp);
    var vector = cvss.vector.toLowerCase();
    var metrics = ["av", "ac", "au", "c", "i", "a"];
    var v_pos = [3, 8, 13, 17, 21, 25];
    $.each(metrics, function(i, metric){
      var j_elm = $("<span>");
      var val = vector[v_pos[i]];
      if(opts.size === "s"){
        j_elm.attr("class", "_cvss_vector_icon cvss_icon_s cvss_icon_s_img cvss_icon_s_base_" + metric + "_" + val);
      }else{
        j_elm.attr("class", "_cvss_vector_icon cvss_icon_m cvss_icon_m_img cvss_icon_m_base_" + metric + "_" + val);
      }
      j_box.append(j_elm);
    });
    return j_box;
  };

  _this.render_vuln_content_all = function(){
    var j_content = $(".j_vuln_content");
    var vuln = _this.vuln;
    var vuln_tab = _this.vuln_tab;
    var vuln_content = _this.vuln_content;
    $(".j_vuln_tab._active").removeClass("_active").addClass("_inactive");
    $(".j_vuln_tab[data-tab=\"" + vuln_tab + "\"]").removeClass("_inactive").addClass("_active");

    var tabs = [];
    $(".j_vuln_tab").each(function(i,elm){
      if(elm.dataset.tab !== "all"){
        tabs.push({tab:elm.dataset.tab, name:elm.textContent});
      }
    });

    j_content.empty();
    tabs.forEach(function(t){
      var j_subbox = $("<div>");
      var j_head = $("<div>")
      var j_subcontent = $("<div>");
      j_head
        .text(t.name)
        .addClass("_sub_head")
      ;
      j_subbox
        .append(j_head)
        .addClass("_sub_box")
      ;
      j_subcontent
        .addClass("_sub_content")
      ;
      if(vuln_content[t.tab] == null){
        if(t.tab === "description"){
          var phtml = vuln.content.description;
          var formatter = new SidContentFormatter(vuln);
          var phtml = formatter.embed_cvss_elms(vuln.content.description);
          j_subcontent.html(phtml)
          j_subbox.append(j_subcontent);
          j_content.append(j_subbox);
          formatter.render_cvss_radars();
          vuln_content[t.tab] = j_subcontent.html();
        }else{
          var phtml = vuln.content[t.tab];
          vuln_content[t.tab] = phtml;
          j_subcontent.html(phtml);
          j_subbox.append(j_subcontent);
          j_content.append(j_subbox);
        }
      }else{
        j_subcontent.html(vuln_content[t.tab]);
        j_subbox.append(j_subcontent);
        j_content.append(j_subbox);
      }
    });
  };

  _this.render_vuln_content = function(){
    var j_content = $(".j_vuln_content");
    var vuln = _this.vuln;
    var vuln_tab = _this.vuln_tab;
    var vuln_content = _this.vuln_content;
    $(".j_vuln_tab._active").removeClass("_active").addClass("_inactive");
    $(".j_vuln_tab[data-tab=\"" + vuln_tab + "\"]").removeClass("_inactive").addClass("_active");

    j_content.empty();
    if(vuln_content[vuln_tab] == null){
      if(vuln_tab === "description"){
        var phtml = vuln.content.description;
        var formatter = new SidContentFormatter(vuln);
        var phtml = formatter.embed_cvss_elms(vuln.content.description);
        phtml = phtml.replace(/href="vuln_id=(\d+)"/g, "href=\"$1\"");
        j_content.append(phtml);
        formatter.render_cvss_radars();

        vuln_content[vuln_tab] = j_content.html();
      }else{
        var phtml = vuln.content[vuln_tab];
        phtml = phtml.replace(/href="vuln_id=(\d+)"/g, "href=\"$1\"");
        vuln_content[vuln_tab] = phtml;
        j_content.html(phtml);
      }
    }else{
      j_content.html(vuln_content[vuln_tab]);
    }
  };

  _this.bind_event = function(){
    $(".j_vuln_tab").on("click", function(){_this.click_vuln_tab(this)});
    $(".j_vers_switch").on("click", function(){_this.click_vers_switch(this)});
  };

  _this.click_vers_switch = function(elm){
    var j_elm = $(elm);
    var j_product_box = j_elm.closest(".j_affect_product_box");
    var j_vers = j_product_box.find(".j_affect_product_vers");
    var j_icon = j_product_box.find(".j_vers_switch_icon");
    if(j_vers.css("display") === "none"){
      j_vers.show();
      j_icon.html("&#x229f;");
    }else{
      j_vers.hide();
      j_icon.html("&#x229e;");
    }
  };

  _this.click_vuln_tab = function(elm){
    var j_tab = $(elm);
    _this.vuln_tab = j_tab.data("tab");
    if(_this.vuln_tab == "all"){
      _this.render_vuln_content_all();
    }else{
      _this.render_vuln_content();
    }
  };

  return _this;
})();

$(function(){
  "use strict";
  vuln_box.show();

  function ControlActionArea(){
    var content_height = $('#vuln-content').outerHeight();
    var wrap_ActionArea = $('#wrap-ActionArea');
    if( $(window).height() < content_height + wrap_ActionArea.height() ){
      if( wrap_ActionArea.find('footer').length === 0){
        wrap_ActionArea.append($('footer'));
      }
      $('#hidden-space').height(wrap_ActionArea.height());
      wrap_ActionArea.addClass('sticky');
    }else{
        $('#hidden-space').height('0');
        wrap_ActionArea.removeClass('sticky');
    }
  };

  $('#download-vulninfo-tsv').on('click', function(){
    var conf = confirm('ファイルをダウンロードします');
    if( !conf ){
      return false;
    }
    $('body').append(create_loading_window());
     
    $.ajax({
      type: 'POST',
      url: $('#read_download_data_path').val(),
      data: { 'vuln_info': $('#vuln_info').val() }
    }).done(function(data){
      if( data['err_message'].length > 0  ){
        $('#checking-window').remove();
        alert(data['err_message']);
        return false;
      }
      $('#form-download').submit();
      $('#checking-window').remove();
    }).fail(function(){
      $('#checking-window').remove();
      alert('ダウンロードに失敗しました。');
      return false;
    });
  });
  var wrap_ActionArea = $('#wrap-ActionArea');
  var timer_stcky_control = setInterval(function(){
    if( wrap_ActionArea.is(':visible') ){
      ControlActionArea();
      clearInterval(timer_stcky_control);
    }
  },100);
  $('._vuln_menu').on('click', function(){
    ControlActionArea();
  });
  $(window).on('resize', function(){
    ControlActionArea();
  });
});


