class CreateSidfmdProbeData < ActiveRecord::Migration
  def change
    create_table :sidfmd_probes do |t|
      t.references :sidfmd_probe_apikey, foreign_key: true, index: true, null: false
      t.boolean :flg_enable, null: false, default: false
      t.text :kind, null: false
      t.text :version, null: false
      t.timestamps
    end

    create_table :sidfmd_probe_sshes do |t|
      t.references :sidfmd_probe, foreign_key: true, index: true, null: false
      t.text :datekey, index: true, null: false
    end

    create_table :sidfmd_probe_ssh_ips do |t|
      t.references :sidfmd_probe_ssh, foreign_key: true, index: true, null: false
      t.text :ipaddress

      # ping
      t.boolean :is_ping

      # hostinfo
      t.text :hostname_f
      t.text :hostname_s
      t.text :ident
      t.text :version
      t.text :name
    end

    # nmap
    create_table :sidfmd_probe_ssh_ip_nmaps do |t|
      t.references :sidfmd_probe_ssh_ip, foreign_key: true, index: true, null: false
      t.text :open_port
    end

    # ssh
    create_table :sidfmd_probe_ssh_ip_sshes do |t|
      t.references :sidfmd_probe_ssh_ip, foreign_key: true, index: true, null: false
      t.integer :port
      t.text :authtype
      t.text :username
    end

    # hostinfo
    create_table :sidfmd_probe_ssh_ip_pkgs do |t|
      t.references :sidfmd_probe_ssh_ip, foreign_key: true, index: true, null: false
      t.text :pkg
    end
  end
end
