#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

module UserData

  def create_user(
    role: 'admin',
    login: nil,
    mail: nil,
    mail_notification: false,
    password: '11111111',
    lastname: 'test',
    firstname: 'test',
    categories: nil
  )
    unless login then
      login = "#{User.order(:login).last.login}1"
    end
    unless mail then
      mail = "#{EmailAddress.order(:address).last.address}a"
    end
    user = User.new
    user.login = login
    user.password = password
    user.password_confirmation = password
    user.lastname = lastname
    user.firstname = firstname
    user.mail = mail
    user.mail_notification = mail_notification ? "only_my_events" : "none"
    if categories then
      user.sidfmd_categories = categories
    end
    user.save
    role_name =
      case role
      when "admin" then
        "SIDfmVM管理者"
      when "mng" then
        "SIDfmVM報告者"
      when "use" then
        "SIDfmVM利用者"
      when "view" then
        "SIDfmVM閲覧者"
      else
        "Anonymous"
      end
    project = Project.find_by(:name => "脆弱性情報管理")
    role = Role.find_by(:name => role_name)
    Member.create_principal_memberships(user, :project_ids => [ project.id ], :role_ids => role.id)
    user
  end

end
